# This file was generated by liblab | https://liblab.com/

from typing import Union
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .base import OneOfBaseModel


@JsonMap({"id_": "id"})
class CreateApiVersion1Schemas(BaseModel):
    """Information about the schema.

    :param id_: The schema's ID., defaults to None
    :type id_: str, optional
    """

    def __init__(self, id_: str = None):
        if id_ is not None:
            self.id_ = id_


@JsonMap({"id_": "id"})
class CreateApiVersion1Collections(BaseModel):
    """Information about the collection.

    :param id_: The collection's ID., defaults to None
    :type id_: str, optional
    """

    def __init__(self, id_: str = None):
        if id_ is not None:
            self.id_ = id_


@JsonMap({"release_notes": "releaseNotes"})
class CreateApiVersion1(BaseModel):
    """Information about the API version.

    :param name: The version's name.
    :type name: str
    :param schemas: A list of the version's schemas.
    :type schemas: List[CreateApiVersion1Schemas]
    :param collections: A list of the version's collections.
    :type collections: List[CreateApiVersion1Collections]
    :param release_notes: Information about the API version release. For example, changelog notes., defaults to None
    :type release_notes: str, optional
    """

    def __init__(
        self,
        name: str,
        schemas: List[CreateApiVersion1Schemas],
        collections: List[CreateApiVersion1Collections],
        release_notes: str = None,
    ):
        self.name = name
        self.schemas = self._define_list(schemas, CreateApiVersion1Schemas)
        self.collections = self._define_list(collections, CreateApiVersion1Collections)
        if release_notes is not None:
            self.release_notes = release_notes


@JsonMap({"file_path": "filePath"})
class CreateApiVersion2Schemas(BaseModel):
    """Information about the schema.

    :param file_path: The path to the schema root file in the Git repository., defaults to None
    :type file_path: str, optional
    """

    def __init__(self, file_path: str = None):
        if file_path is not None:
            self.file_path = file_path


@JsonMap({"file_path": "filePath"})
class CreateApiVersion2Collections(BaseModel):
    """Information about the collection.

    :param file_path: Path to a collection in the Git repository., defaults to None
    :type file_path: str, optional
    """

    def __init__(self, file_path: str = None):
        if file_path is not None:
            self.file_path = file_path


@JsonMap({"release_notes": "releaseNotes"})
class CreateApiVersion2(BaseModel):
    """Information about the API version.

    :param name: The version's name.
    :type name: str
    :param branch: The branch ID.
    :type branch: str
    :param schemas: A list of the version's schemas.
    :type schemas: List[CreateApiVersion2Schemas]
    :param collections: A list of the version's collections.
    :type collections: List[CreateApiVersion2Collections]
    :param release_notes: Information about the API version release. For example, changelog notes., defaults to None
    :type release_notes: str, optional
    """

    def __init__(
        self,
        name: str,
        branch: str,
        schemas: List[CreateApiVersion2Schemas],
        collections: List[CreateApiVersion2Collections],
        release_notes: str = None,
    ):
        self.name = name
        self.branch = branch
        self.schemas = self._define_list(schemas, CreateApiVersion2Schemas)
        self.collections = self._define_list(collections, CreateApiVersion2Collections)
        if release_notes is not None:
            self.release_notes = release_notes


@JsonMap({"directory_path": "directoryPath"})
class CreateApiVersion3Schemas(BaseModel):
    """Information about the schema.

    :param directory_path: The path to the root directory where schemas are stored in the Git repository., defaults to None
    :type directory_path: str, optional
    """

    def __init__(self, directory_path: str = None):
        if directory_path is not None:
            self.directory_path = directory_path


@JsonMap({"file_path": "filePath"})
class CreateApiVersion3Collections(BaseModel):
    """Information about the collection.

    :param file_path: The path to the collection in the Git repository., defaults to None
    :type file_path: str, optional
    """

    def __init__(self, file_path: str = None):
        if file_path is not None:
            self.file_path = file_path


@JsonMap({"release_notes": "releaseNotes"})
class CreateApiVersion3(BaseModel):
    """Information about the API version.

    :param name: The version's name.
    :type name: str
    :param branch: The branch ID.
    :type branch: str
    :param schemas: A list of the version's schemas.
    :type schemas: List[CreateApiVersion3Schemas]
    :param collections: A list of the version's collections.
    :type collections: List[CreateApiVersion3Collections]
    :param release_notes: Information about the API version release. For example, changelog notes., defaults to None
    :type release_notes: str, optional
    """

    def __init__(
        self,
        name: str,
        branch: str,
        schemas: List[CreateApiVersion3Schemas],
        collections: List[CreateApiVersion3Collections],
        release_notes: str = None,
    ):
        self.name = name
        self.branch = branch
        self.schemas = self._define_list(schemas, CreateApiVersion3Schemas)
        self.collections = self._define_list(collections, CreateApiVersion3Collections)
        if release_notes is not None:
            self.release_notes = release_notes


class CreateApiVersionRequestGuard(OneOfBaseModel):
    class_list = {
        "CreateApiVersion1": CreateApiVersion1,
        "CreateApiVersion2": CreateApiVersion2,
        "CreateApiVersion3": CreateApiVersion3,
    }


CreateApiVersionRequest = Union[CreateApiVersion1, CreateApiVersion2, CreateApiVersion3]
