# This file was generated by liblab | https://liblab.com/

from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({})
class RespondPanElementAddRequestResponse(BaseModel):
    """The response to the user's request.

    :param message: A message that details why the user's request was denied., defaults to None
    :type message: str, optional
    """

    def __init__(self, message: str = None):
        if message is not None:
            self.message = message


class RespondPanElementAddRequestStatus(Enum):
    """An enumeration representing different categories.

    :cvar DENIED: "denied"
    :vartype DENIED: str
    :cvar APPROVED: "approved"
    :vartype APPROVED: str
    """

    DENIED = "denied"
    APPROVED = "approved"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(
                lambda x: x.value,
                RespondPanElementAddRequestStatus._member_map_.values(),
            )
        )


@JsonMap({})
class PrivateApiNetworkRespondPanElementAddRequestRequest1(BaseModel):
    """PrivateApiNetworkRespondPanElementAddRequestRequest1

    :param response: The response to the user's request., defaults to None
    :type response: RespondPanElementAddRequestResponse, optional
    :param status: The request's status.
    :type status: RespondPanElementAddRequestStatus
    """

    def __init__(
        self,
        status: RespondPanElementAddRequestStatus,
        response: RespondPanElementAddRequestResponse = None,
    ):
        if response is not None:
            self.response = self._define_object(
                response, RespondPanElementAddRequestResponse
            )
        self.status = self._enum_matching(
            status, RespondPanElementAddRequestStatus.list(), "status"
        )
